
#include "Eprimtv.h"

#include "Etet10.h"

TET10_SUBTRI_VERTS;
TET10_SUBTRI_IS_BDRY_EDGE;

#define SHRINK_TETRA_DATA(theSHRINK, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9) \
  {                                                                          \
     double thecv;                                                           \
                                                                             \
     thecv  = (v0);                                                          \
     thecv += (v1);                                                          \
     thecv += (v2);                                                          \
     thecv += (v3);                                                          \
     thecv += (v4);                                                          \
     thecv += (v5);                                                          \
     thecv += (v6);                                                          \
     thecv += (v7);                                                          \
     thecv += (v8);                                                          \
     thecv += (v9);                                                          \
     thecv *= 0.1;                                                           \
     (v0) = thecv + (theSHRINK) * ((v0)  - thecv);                           \
     (v1) = thecv + (theSHRINK) * ((v1)  - thecv);                           \
     (v2) = thecv + (theSHRINK) * ((v2)  - thecv);                           \
     (v3) = thecv + (theSHRINK) * ((v3)  - thecv);                           \
     (v4) = thecv + (theSHRINK) * ((v4)  - thecv);                           \
     (v5) = thecv + (theSHRINK) * ((v5)  - thecv);                           \
     (v6) = thecv + (theSHRINK) * ((v6)  - thecv);                           \
     (v7) = thecv + (theSHRINK) * ((v7)  - thecv);                           \
     (v8) = thecv + (theSHRINK) * ((v8)  - thecv);                           \
     (v9) = thecv + (theSHRINK) * ((v9)  - thecv);                           \
   }


void 
EVTet10Primitive (EView        *v_p,
                  GraphicObj   *g_p,
                  WCRec         points[10],
                  EPixel        pixel,
                  int           fill,
                  int           edge_flag,
                  EPixel        edge_color,
                  float         shrink,
                  EDrawMode     draw_mode)
{
  WCRec s[10];
  int how_many_in = 0;
  EV_line_end_point_rec ap;
  BOOLEAN mclip;
  int i;

  for (i = 0; i < 10; i++) {
    COPY_WCREC(&s[i], &points[i]);
  }
  if (shrink != 1) {
    SHRINK_TETRA_DATA (shrink,
                       s[0].x, s[1].x, s[2].x, s[3].x, s[4].x, 
                       s[5].x, s[6].x, s[7].x, s[8].x, s[9].x);
    SHRINK_TETRA_DATA (shrink,
                       s[0].y, s[1].y, s[2].y, s[3].y, s[4].y, 
                       s[5].y, s[6].y, s[7].y, s[8].y, s[9].y);
    SHRINK_TETRA_DATA (shrink,
                       s[0].z, s[1].z, s[2].z, s[3].z, s[4].z, 
                       s[5].z, s[6].z, s[7].z, s[8].z, s[9].z);
  }

  mclip = (v_p->should_clip_by_model_planes
           && EGIsClippable(g_p)
           && v_p->model_clip_plane.clip_is_on);
  if (mclip) {
    if (EGInvisibleWhenClipped(g_p)) {
      int i;
      for (i = 0; i < 10; i++) {
        COPY_WCREC(&ap.loc.wc, &s[i]);
        if (point_is_in_IN_halfspace(&ap, &v_p->model_clip_plane.center,
                                     &v_p->model_clip_plane.normal))
          how_many_in++;
      }
      if (how_many_in == 0)
        return;
      if (how_many_in != 10)
        return;
    }
  }
  

  if (v_p->render_mode == WIRE_RENDERING || fill == FILL_HOLLOW) {
#define LINES(i, j, k)                                          \
    {                                                           \
      EVLine3DPrimitive (v_p, g_p, &s[i], &s[j],                \
                         SOLID_STYLE, pixel, 0, draw_mode);     \
      EVLine3DPrimitive (v_p, g_p, &s[j], &s[k],                \
                         SOLID_STYLE, pixel, 0, draw_mode);     \
    }
    LINES (0, 6, 2);
    LINES (2, 5, 1);
    LINES (1, 4, 0);
    LINES (3, 9, 2);
    LINES (1, 8, 3);
    LINES (0, 7, 3);
  } else {
    WCRec vpn, n, V1, V2;
    int i0, i1, i2, k;
    
    /* Cull the back-facing triangles */

#define TRI_NORMAL(RESLT_VEC, VEC1, VEC2)                            \
    {                                                                \
    (RESLT_VEC)->x = (VEC1)->y * (VEC2)->z - (VEC1)->z * (VEC2)->y;  \
    (RESLT_VEC)->y = (VEC1)->z * (VEC2)->x - (VEC1)->x * (VEC2)->z;  \
    (RESLT_VEC)->z = (VEC1)->x * (VEC2)->y - (VEC1)->y * (VEC2)->x;  \
    }

#define SUBTR_WCRECS(RESLT_VEC, VEC1, VEC2)                \
    {                                                      \
    (RESLT_VEC)->x = (VEC1)->x - (VEC2)->x;                \
    (RESLT_VEC)->y = (VEC1)->y - (VEC2)->y;                \
    (RESLT_VEC)->z = (VEC1)->z - (VEC2)->z;                \
    }

#define DPROD(VEC1, VEC2) \
   ((VEC1)->x * (VEC2)->x + (VEC1)->y * (VEC2)->y + (VEC1)->z * (VEC2)->z) 

#define BACKFACE_CULL(TRI_NORMAL_PTR, VIEW_PLANE_NORMAL_PTR) \
   (DPROD(TRI_NORMAL_PTR, VIEW_PLANE_NORMAL_PTR) > 0         \
    || mclip)
  
  EVGetNormal(v_p, &vpn);
    
    for (k = 0; k < 16; k++) {
      i0 = tet10_subtri_verts[k][0];
      i1 = tet10_subtri_verts[k][1];
      i2 = tet10_subtri_verts[k][2];
      SUBTR_WCRECS(&V1, &s[i0], &s[i1]);
      SUBTR_WCRECS(&V2, &s[i0], &s[i2]);
      TRI_NORMAL(&n, &V1, &V2);
      if (BACKFACE_CULL(&n, &vpn)) 
        evtriangle3dprimitive_ (v_p, g_p, &s[i0], &s[i1], &s[i2], pixel, fill,
                                edge_flag, edge_color, 1.0, draw_mode,
                                tet10_subtri_is_bdry_edge[k][0],
                                tet10_subtri_is_bdry_edge[k][1],
                                tet10_subtri_is_bdry_edge[k][2]);
    }
  } /* else */
}

