
#include "Eprimtv.h"

#include "Etri6.h"

TRI6_SUBTRI_VERTS;
TRI6_SUBTRI_IS_BDRY_EDGE;

#define SHRINK_TRI_DATA(theSHRINK, v0, v1, v2, v3, v4, v5) \
  {                                                                          \
     double thecv;                                                           \
                                                                             \
     thecv  = (v0);                                                          \
     thecv += (v1);                                                          \
     thecv += (v2);                                                          \
     thecv += (v3);                                                          \
     thecv += (v4);                                                          \
     thecv += (v5);                                                          \
     thecv /= 6.0;                                                           \
     (v0) = thecv + (theSHRINK) * ((v0)  - thecv);                           \
     (v1) = thecv + (theSHRINK) * ((v1)  - thecv);                           \
     (v2) = thecv + (theSHRINK) * ((v2)  - thecv);                           \
     (v3) = thecv + (theSHRINK) * ((v3)  - thecv);                           \
     (v4) = thecv + (theSHRINK) * ((v4)  - thecv);                           \
     (v5) = thecv + (theSHRINK) * ((v5)  - thecv);                           \
   }


void 
EVTri6Primitive (EView        *v_p,
                  GraphicObj   *g_p,
                  WCRec         points[6],
                  EPixel        pixel,
                  int           fill,
                  int           edge_flag,
                  EPixel        edge_color,
                  float         shrink,
                  EDrawMode     draw_mode)
{
  WCRec s[6];
  int how_many_in = 0;
  EV_line_end_point_rec ap;
  BOOLEAN mclip;
  int i;

  for (i = 0; i < 6; i++) {
    COPY_WCREC(&s[i], &points[i]);
  }
  if (shrink != 1) {
    SHRINK_TRI_DATA (shrink, s[0].x, s[1].x, s[2].x, s[3].x, s[4].x, s[5].x);
    SHRINK_TRI_DATA (shrink, s[0].y, s[1].y, s[2].y, s[3].y, s[4].y, s[5].y);
    SHRINK_TRI_DATA (shrink, s[0].z, s[1].z, s[2].z, s[3].z, s[4].z, s[5].z);
  }

  mclip = (v_p->should_clip_by_model_planes
           && EGIsClippable(g_p)
           && v_p->model_clip_plane.clip_is_on);
  if (mclip) {
    if (EGInvisibleWhenClipped(g_p)) {
      int i;
      for (i = 0; i < 6; i++) {
        COPY_WCREC(&ap.loc.wc, &s[i]);
        if (point_is_in_IN_halfspace(&ap, &v_p->model_clip_plane.center,
                                     &v_p->model_clip_plane.normal))
          how_many_in++;
      }
      if (how_many_in == 0)
        return;
      if (how_many_in != 6)
        return;
    }
  }
  

  if (v_p->render_mode == WIRE_RENDERING || fill == FILL_HOLLOW) {
#define LINES(i, j, k)                                          \
    {                                                           \
      EVLine3DPrimitive (v_p, g_p, &s[i], &s[j],                \
                         SOLID_STYLE, pixel, 0, draw_mode);     \
      EVLine3DPrimitive (v_p, g_p, &s[j], &s[k],                \
                         SOLID_STYLE, pixel, 0, draw_mode);     \
    }
    LINES (0, 3, 1);
    LINES (1, 4, 2);
    LINES (2, 5, 0);
  } else {
    WCRec vpn, n, V1, V2;
    int i0, i1, i2, k;
    
    for (k = 0; k < 4; k++) {
      i0 = tri6_subtri_verts[k][0];
      i1 = tri6_subtri_verts[k][1];
      i2 = tri6_subtri_verts[k][2];
      evtriangle3dprimitive_ (v_p, g_p, &s[i0], &s[i1], &s[i2], pixel, fill,
                              edge_flag, edge_color, 1.0, draw_mode,
                              tri6_subtri_is_bdry_edge[k][0],
                              tri6_subtri_is_bdry_edge[k][1],
                              tri6_subtri_is_bdry_edge[k][2]);
    }
  } /* else */
}

